searchNodes=[{"ref":"Differ.html","title":"Differ","type":"module","doc":"Module that computes diff for terms Using with structs It is possible to use Differ with structs, you need to derive default implementation for Differ.Diffable and Differ.Patchable protocols: defmodule User do @derive [Differ.Diffable, Differ.Patchable] defstruct name: &quot;&quot;, age: 21 end And now you can call Differ.diff/2 with your structs: iex&gt; Differ.diff(%User{name: &quot;John&quot;}, %User{name: &quot;John Smith&quot;}) [{:name, :diff, [eq: &quot;John&quot;, ins: &quot; Smith&quot;]}, {:age, :eq, 21}] You can skip some fields aswell (e.g. timestamps, id), by using skip option, when deriving default implementation @derive [{Differ.Diffable, skip: [:updated_at, :diffs]}, Differ.Patchable] schema &quot;posts&quot; do field :content, :string field :tags, {:array, :string} field :title, :string field :diffs, {:array, Diff}, default: [] timestamps() end"},{"ref":"Differ.html#diff/2","title":"Differ.diff/2","type":"function","doc":"Returns diff between 2 terms that implement Differ.Diffable protocol Diff here is edit script, that should be compatible with List.myers_difference/3 Examples iex&gt; Differ.diff(%{key: &quot;value&quot;}, %{key: &quot;value&quot;}) [eq: %{key: &quot;value&quot;}] iex&gt; Differ.diff(&quot;Hello!&quot;, &quot;Hey!&quot;) [eq: &quot;He&quot;, del: &quot;llo&quot;, ins: &quot;y&quot;, eq: &quot;!&quot;]"},{"ref":"Differ.html#optimize/2","title":"Differ.optimize/2","type":"function","doc":"Optimizes diff size Optimizes size by removing data that is not relevant for change. There is 3 levels of optimization: Safe - can have conflicts, can be reverted Safe-ish - you lose ability to get conflicts, but still can be reverted Un-safe - no conflicts and no reverting Examples iex&gt; regular_diff = Differ.diff(%{&quot;same&quot; =&gt; &quot;same&quot;}, %{&quot;same&quot; =&gt; &quot;same&quot;, &quot;new&quot; =&gt; &quot;val&quot;}) [{&quot;same&quot;, :eq, &quot;same&quot;}, {&quot;new&quot;, :ins, &quot;val&quot;}] iex&gt; Differ.optimize(regular_diff) [{&quot;new&quot;, :ins, &quot;val&quot;}] iex&gt; diff = Differ.diff(&quot;Somewhat long string with a litle change athere&quot;, &quot;Somewhat long string with a litle change here&quot;) [eq: &quot;Somewhat long string with a litle change &quot;, del: &quot;at&quot;, eq: &quot;here&quot;] iex&gt; Differ.optimize(diff, 2) [skip: 41, del: &quot;at&quot;, skip: 4] iex&gt; Differ.optimize(diff, 3) [skip: 41, remove: 2, skip: 4]"},{"ref":"Differ.html#patch/2","title":"Differ.patch/2","type":"function","doc":"Applies diff and returns patched value Examples iex&gt; old_list = [&quot;22&quot;, &quot;1&quot;] iex&gt; diff = Differ.diff(old_list, [&quot;2&quot;, &quot;1&quot;, &quot;3&quot;]) iex&gt; Differ.patch(old_list, diff) {:ok, [&quot;2&quot;, &quot;1&quot;, &quot;3&quot;]}"},{"ref":"Differ.html#patch!/2","title":"Differ.patch!/2","type":"function","doc":"Same as Differ.patch/2, but returns value and throws on error"},{"ref":"Differ.html#revert/2","title":"Differ.revert/2","type":"function","doc":"Reverts diff and returns patched value Examples iex&gt; old_list = [&quot;22&quot;, &quot;1&quot;] iex&gt; new_list = [&quot;2&quot;, &quot;1&quot;, &quot;3&quot;] iex&gt; diff = Differ.diff(old_list, new_list) iex&gt; Differ.revert(new_list, diff) {:ok, [&quot;22&quot;, &quot;1&quot;]}"},{"ref":"Differ.html#revert!/2","title":"Differ.revert!/2","type":"function","doc":"Same as Differ.revert/2, but returns value and throws on error"},{"ref":"Differ.html#show_diff/4","title":"Differ.show_diff/4","type":"function","doc":"Allows to visualize diff Applies diff to a term and calls cb on each operation, result of cb will be used to construct new value for term Options revert - reverts term with given diff, before apply (default true) Examples iex&gt; Differ.show_diff(&quot;qwerty&quot;, [eq: &quot;qwer&quot;, del: &quot;123&quot;, ins: &quot;ty&quot;], ...&gt; fn {op, val} -&gt; ...&gt; case op do ...&gt; :del -&gt; &quot;--&quot; &lt;&gt; val ...&gt; :ins -&gt; &quot;++&quot; &lt;&gt; val ...&gt; _ -&gt; val ...&gt; end ...&gt; end) {:ok, &quot;qwer--123++ty&quot;}"},{"ref":"Differ.Diffable.html","title":"Differ.Diffable","type":"protocol","doc":"Allows to compute diff between terms"},{"ref":"Differ.Diffable.html#diff/2","title":"Differ.Diffable.diff/2","type":"function","doc":"Returns a list of tuples that represents an edit script When implementing this function on a new type, you should always implement this def diff(term, term), do: [eq: term]"},{"ref":"Differ.Diffable.html#optimize_op/3","title":"Differ.Diffable.optimize_op/3","type":"function","doc":"Optimizes diff operation, to reduce its size If it returns nil, then operation can be excluded from diff"},{"ref":"Differ.Diffable.html#t:diff/0","title":"Differ.Diffable.diff/0","type":"type","doc":"List of operations need to be applied"},{"ref":"Differ.Diffable.html#t:level/0","title":"Differ.Diffable.level/0","type":"type","doc":"Level of optimization"},{"ref":"Differ.Diffable.html#t:operation/0","title":"Differ.Diffable.operation/0","type":"type","doc":"Defines operator and value that need to be applied with operator Examples {:del, &quot;s&quot;} {:skip, 4} {&quot;key&quot;, :ins, &quot;s&quot;}"},{"ref":"Differ.Diffable.html#t:operator/0","title":"Differ.Diffable.operator/0","type":"type","doc":"Operators that define how to change data :del - delete :ins - insert :eq - doesnt change :diff - nested diff that should be applied :skip - skip number of characters or elements :remove - remove number of characters or elements (Non-revertable)"},{"ref":"Differ.Diffable.html#t:t/0","title":"Differ.Diffable.t/0","type":"type","doc":"Diffable term"},{"ref":"Differ.Patchable.html","title":"Differ.Patchable","type":"protocol","doc":"Allows to apply diff to a term"},{"ref":"Differ.Patchable.html#perform/3","title":"Differ.Patchable.perform/3","type":"function","doc":"Performs operation op on term First argument is original term. Second is operation, that get matched against functions in implementations. Third is a tuple, where first item should be result of the operation, and second is anything else. Function should return tuple with :ok atom and tuple {result, anything}"},{"ref":"Differ.Patchable.html#perform/4","title":"Differ.Patchable.perform/4","type":"function","doc":""},{"ref":"Differ.Patchable.html#revert_op/2","title":"Differ.Patchable.revert_op/2","type":"function","doc":"Returns the opposite of operation If operation is not revertable, should return {:error, reason} Examples iex&gt; Differ.diffable.revert(&quot;&quot;, {:del, &quot;ttypo&quot;}) {:ok, {:ins, &quot;ttypo&quot;}} iex&gt; Differ.diffable.revert(&quot;&quot;, {:remove, 10}) {:error, &quot;Operation is not revertable&quot;}"},{"ref":"Differ.Patchable.html#t:reason/0","title":"Differ.Patchable.reason/0","type":"type","doc":""},{"ref":"Differ.Patchable.html#t:t/0","title":"Differ.Patchable.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Differ","type":"extras","doc":"Differ Small library for creating diffs and applying them iex&gt; Differ.diff(&quot;Hello!&quot;, &quot;Hey!&quot;) [eq: &quot;He&quot;, del: &quot;llo&quot;, ins: &quot;y&quot;, eq: &quot;!&quot;] iex&gt; Differ.patch(&quot;Hello!&quot;, [eq: &quot;He&quot;, del: &quot;llo&quot;, ins: &quot;y&quot;, eq: &quot;!&quot;]) {:ok, &quot;Hey!&quot;}"},{"ref":"readme.html#installation","title":"Differ - Installation","type":"extras","doc":"The package can be installed by adding differ to your list of dependencies in mix.exs: def deps do [ {:differ, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#documentation","title":"Differ - Documentation","type":"extras","doc":"Documentation can be found at https://hexdocs.pm/differ."},{"ref":"readme.html#usage","title":"Differ - Usage","type":"extras","doc":"Simple diff of two maps iex&gt; user = %{name: &quot;John&quot;} iex&gt; updated_user = Map.put(user, :age, 25) iex&gt; Differ.diff(user, updated_user) [{:name, :eq, &quot;John&quot;}, {:age, :ins, 25}] For lists and strings using List.myers_difference/3 and String.myers_difference/2 respectevly. So diffs of lists and strings a excactly output of this functions iex&gt; Differ.diff(&quot;Hello!&quot;, &quot;Hey!&quot;) [eq: &quot;He&quot;, del: &quot;llo&quot;, ins: &quot;y&quot;, eq: &quot;!&quot;] It is possible to use Differ with structs, you need to derive default implementation for Differ.Diffable and Differ.Patchable protocols: defmodule User do @derive [Differ.Diffable, Differ.Patchable] defstruct name: &quot;&quot;, age: 21 end And now you can call Differ.diff/2 with your structs: iex&gt; Differ.diff(%User{name: &quot;John&quot;}, %User{name: &quot;John Smith&quot;}) [{:name, :diff, [eq: &quot;John&quot;, ins: &quot; Smith&quot;]}, {:age, :eq, 21}] As well as creating diffs, you can apply diff to a term. There is Differ.patch/2 and Differ.revert/2 for this purposes. iex&gt; diff = Differ.diff(&quot;Hello!&quot;, &quot;Hey!&quot;) iex&gt; Differ.patch(&quot;Hello!&quot;, diff) {:ok, &quot;Hey!&quot;} or revert diff iex&gt; Differ.revert(&quot;Hey!&quot;, diff) {:ok, &quot;Hello!&quot;} For more examples look at the docs."}]